﻿Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.WinForms

Public Class Form1
  Private moShapeFileLayer As ShapeFileFeatureLayer
  'Private msShapeFilePath As String = "..\..\Data\StandsSubset.shp"
  Private msShapeFilePath As String = "..\..\Data\Boonies.shp"
  Private Const mciNad_83_Zone_15 As Integer = 26915
  Private Const mciAlbers_Contiguous_USA As Integer = 102003
  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    moShapeFileLayer = New ShapeFileFeatureLayer(msShapeFilePath)
    'moShapeFileLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(AreaStyles.CreateSimpleAreaStyle(GeoColors.Transparent, GeoColors.DarkSlateBlue, 1))
    moShapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColors.Transparent, GeoColors.DarkSlateBlue, 1)
    moShapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

    WinformsMap1.Overlays.Add("Shapefile", New LayerOverlay())
    CType(WinformsMap1.Overlays("Shapefile"), LayerOverlay).Layers.Add(moShapeFileLayer)

    moShapeFileLayer.Open()
    Dim oProj4 As New Proj4Projection
    oProj4.InternalProjectionParametersString = Proj4Projection.GetEsriParametersString(mciAlbers_Contiguous_USA)
    oProj4.ExternalProjectionParametersString = Proj4Projection.GetEsriParametersString(mciNad_83_Zone_15)


    moShapeFileLayer.FeatureSource.Projection = oProj4
    oProj4.Open()

    WinformsMap1.MinimumScale = 1
    WinformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.SnapUp
    ZoomLevelHelper.InitZoomLevels()



    WinformsMap1.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter

    WinformsMap1.CurrentExtent = moShapeFileLayer.GetBoundingBox
    ZoomLevelHelper.ApplyCustomZoomLevels(WinformsMap1.ZoomLevelSet)

    WinformsMap1.Refresh()






  End Sub

  Private Sub btnLabels_Click(sender As Object, e As EventArgs) Handles btnLabels.Click
    mLabelLayer()
  End Sub
  Private Sub mLabelLayer()
    Dim oTextStyle As New TextStyle
    With oTextStyle
      .AllowLineCarriage = False
      .ForceLineCarriage = False
      .DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels
      .TextSolidBrush = New GeoSolidBrush(GeoColors.Black)
      .RotationAngle = 0
      .FittingPolygon = False
      .TextColumnName = "CoverType"
      .Font = New GeoFont("Century Gothic", 8)
      .OverlappingRule = LabelOverlappingRule.NoOverlapping
      .LeaderLineRule = LabelLeaderLinesRule.NoLeaderLines
      .FittingPolygonFactor = 5
      .GridSize = 15
      .FittingPolygonInScreen = True '<-- Setting this property to False makes the problem go away
    End With

    With moShapeFileLayer.ZoomLevelSet

      '.ZoomLevel01.CustomStyles.Add(oTextStyle)
      .ZoomLevel01.DefaultTextStyle = oTextStyle
      .ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

    End With
    Try
      WinformsMap1.Refresh()
    Catch ex As Exception
      MessageBox.Show("Exception Raised:" + ex.Message, "Bad news!", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Try

  End Sub

End Class
